All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Sequencer Middle Level Interface
MIDI Sequencer

## Macros

#define | snd_seq_ev_clear(ev) memset(ev, 0, sizeof(snd_seq_event_t))
| initialize event record More...
#define | snd_seq_ev_set_tag(ev, t) ((ev)->tag = (t))
| set the tag for given event More...
#define | snd_seq_ev_set_dest(ev, c, p) ((ev)->dest.client = (c), (ev)->dest.port = (p))
| set the explicit destination More...
#define | snd_seq_ev_set_subs(ev)
| set broadcasting to subscribers More...
#define | snd_seq_ev_set_broadcast(ev)
| set broadcasting to all clients/ports More...
#define | snd_seq_ev_set_source(ev, p) ((ev)->source.port = (p))
| set the source port More...
#define | snd_seq_ev_set_direct(ev) ((ev)->queue = SND_SEQ_QUEUE_DIRECT)
| set direct passing mode (without queued) More...
#define | snd_seq_ev_schedule_tick(ev, q, relative, ttick)
| set tick-scheduling mode on queue More...
#define | snd_seq_ev_schedule_real(ev, q, relative, rtime)
| set real-time-scheduling mode on queue More...
#define | snd_seq_ev_set_priority(ev, high_prior)
| set event priority More...
#define | snd_seq_ev_set_fixed(ev)
| set fixed data More...
#define | snd_seq_ev_set_variable(ev, datalen, dataptr)
| set variable data More...
#define | snd_seq_ev_set_varusr(ev, datalen, dataptr)
| set varusr data More...
#define | snd_seq_ev_set_queue_control(ev, typ, q, val)
| set queue controls More...
#define | snd_seq_ev_set_queue_start(ev, q) snd_seq_ev_set_queue_control(ev, SND_SEQ_EVENT_START, q, 0)
| set the start queue event More...
#define | snd_seq_ev_set_queue_stop(ev, q) snd_seq_ev_set_queue_control(ev, SND_SEQ_EVENT_STOP, q, 0)
| set the stop queue event More...
#define | snd_seq_ev_set_queue_continue(ev, q) snd_seq_ev_set_queue_control(ev, SND_SEQ_EVENT_CONTINUE, q, 0)
| set the stop queue event More...
#define | snd_seq_ev_set_queue_tempo(ev, q, val) snd_seq_ev_set_queue_control(ev, SND_SEQ_EVENT_TEMPO, q, val)
| set the stop queue event More...
#define | snd_seq_ev_set_queue_pos_real(ev, q, rtime)
| set the real-time position of a queue More...
#define | snd_seq_ev_set_queue_pos_tick(ev, q, ttime)
| set the tick-time position of a queue More...
#define | snd_seq_start_queue(seq, q, ev) snd_seq_control_queue(seq, q, SND_SEQ_EVENT_START, 0, ev)
| start the specified queue More...
#define | snd_seq_stop_queue(seq, q, ev) snd_seq_control_queue(seq, q, SND_SEQ_EVENT_STOP, 0, ev)
| stop the specified queue More...
#define | snd_seq_continue_queue(seq, q, ev) snd_seq_control_queue(seq, q, SND_SEQ_EVENT_CONTINUE, 0, ev)
| continue the specified queue More...
#define | snd_seq_change_queue_tempo(seq, q, tempo, ev) snd_seq_control_queue(seq, q, SND_SEQ_EVENT_TEMPO, tempo, ev)
| change the tempo of the specified queue More...
#define | snd_seq_ev_set_note(ev, ch, key, vel, dur)
| set note event More...
#define | snd_seq_ev_set_noteon(ev, ch, key, vel)
| set note-on event More...
#define | snd_seq_ev_set_noteoff(ev, ch, key, vel)
| set note-off event More...
#define | snd_seq_ev_set_keypress(ev, ch, key, vel)
| set key-pressure event More...
#define | snd_seq_ev_set_controller(ev, ch, cc, val)
| set MIDI controller event More...
#define | snd_seq_ev_set_pgmchange(ev, ch, val)
| set program change event More...
#define | snd_seq_ev_set_pitchbend(ev, ch, val)
| set pitch-bend event More...
#define | snd_seq_ev_set_chanpress(ev, ch, val)
| set channel pressure event More...
#define | snd_seq_ev_set_sysex(ev, datalen, dataptr)
| set sysex event More...

## Functions

int | snd_seq_control_queue (snd_seq_t *seq, int q, int type, int value, snd_seq_event_t *ev)
| queue controls - start/stop/continue More...
int | snd_seq_create_simple_port (snd_seq_t *seq, const char *name, unsigned int caps, unsigned int type)
| create a port - simple version More...
int | snd_seq_delete_simple_port (snd_seq_t *seq, int port)
| delete the port More...
int | snd_seq_connect_from (snd_seq_t *seq, int my_port, int src_client, int src_port)
| simple subscription (w/o exclusive & time conversion) More...
int | snd_seq_connect_to (snd_seq_t *seq, int my_port, int dest_client, int dest_port)
| simple subscription (w/o exclusive & time conversion) More...
int | snd_seq_disconnect_from (snd_seq_t *seq, int my_port, int src_client, int src_port)
| simple disconnection More...
int | snd_seq_disconnect_to (snd_seq_t *seq, int my_port, int dest_client, int dest_port)
| simple disconnection More...
int | snd_seq_set_client_name (snd_seq_t *seq, const char *name)
| set client name More...
int | snd_seq_set_client_event_filter (snd_seq_t *seq, int event_type)
| add client event filter More...
int | snd_seq_set_client_pool_output (snd_seq_t *seq, size_t size)
| change the output pool size of the given client More...
int | snd_seq_set_client_pool_output_room (snd_seq_t *seq, size_t size)
| change the output room size of the given client More...
int | snd_seq_set_client_pool_input (snd_seq_t *seq, size_t size)
| change the input pool size of the given client More...
int | snd_seq_sync_output_queue (snd_seq_t *seq)
| wait until all events are processed More...
int | snd_seq_parse_address (snd_seq_t *seq, snd_seq_addr_t *addr, const char *str)
| parse the given string and get the sequencer address More...
int | snd_seq_reset_pool_output (snd_seq_t *seq)
| reset client output pool More...
int | snd_seq_reset_pool_input (snd_seq_t *seq)
| reset client input pool More...

## Detailed Description

Sequencer Middle Level Interface

## Macro Definition Documentation

#define snd_seq_change_queue_tempo | ( |  | seq,
|  |  | q,
|  |  | tempo,
|  |  | ev
| ) |  | snd_seq_control_queue(seq, q, SND_SEQ_EVENT_TEMPO, tempo, ev)

change the tempo of the specified queue

Parameters

  seq | sequencer handle
  q | queue id
  tempo | the new tempo value
  ev | optional event record (see snd_seq_control_queue)

#define snd_seq_continue_queue | ( |  | seq,
|  |  | q,
|  |  | ev
| ) |  | snd_seq_control_queue(seq, q, SND_SEQ_EVENT_CONTINUE, 0, ev)

continue the specified queue

Parameters

  seq | sequencer handle
  q | queue id to continue
  ev | optional event record (see snd_seq_control_queue)

#define snd_seq_ev_clear | ( |  | ev | ) | memset(ev, 0, sizeof(snd_seq_event_t))

initialize event record

Parameters

  ev | event record pointer

This macro clears the given event record pointer to the default status.

#define snd_seq_ev_schedule_real | ( |  | ev,
|  |  | q,
|  |  | relative,
|  |  | rtime
| ) |  |

Value:
((ev)->flags &= ~(SND_SEQ_TIME_STAMP_MASK | SND_SEQ_TIME_MODE_MASK),\
(ev)->flags |= SND_SEQ_TIME_STAMP_REAL,\
(ev)->flags |= (relative) ? SND_SEQ_TIME_MODE_REL : SND_SEQ_TIME_MODE_ABS,\
(ev)->time.time = *(rtime),\
(ev)->queue = (q))
SND_SEQ_TIME_STAMP_MASK
#define SND_SEQ_TIME_STAMP_MASK
Definition: seq_event.h:213
SND_SEQ_TIME_MODE_ABS
#define SND_SEQ_TIME_MODE_ABS
Definition: seq_event.h:215
SND_SEQ_TIME_STAMP_REAL
#define SND_SEQ_TIME_STAMP_REAL
Definition: seq_event.h:212
SND_SEQ_TIME_MODE_REL
#define SND_SEQ_TIME_MODE_REL
Definition: seq_event.h:216
SND_SEQ_TIME_MODE_MASK
#define SND_SEQ_TIME_MODE_MASK
Definition: seq_event.h:217

set real-time-scheduling mode on queue

Parameters

  ev | event instance
  q | queue id to schedule
  relative | relative time-stamp if non-zero
  rtime | time-stamp to be delivered

This macro sets the scheduling of the event in the realtime mode.

See Also
  snd_seq_ev_schedule_tick(), snd_seq_ev_set_direct()

#define snd_seq_ev_schedule_tick | ( |  | ev,
|  |  | q,
|  |  | relative,
|  |  | ttick
| ) |  |

Value:
((ev)->flags &= ~(SND_SEQ_TIME_STAMP_MASK | SND_SEQ_TIME_MODE_MASK),\
(ev)->flags |= SND_SEQ_TIME_STAMP_TICK,\
(ev)->flags |= (relative) ? SND_SEQ_TIME_MODE_REL : SND_SEQ_TIME_MODE_ABS,\
(ev)->time.tick = (ttick),\
(ev)->queue = (q))
SND_SEQ_TIME_STAMP_MASK
#define SND_SEQ_TIME_STAMP_MASK
Definition: seq_event.h:213
SND_SEQ_TIME_MODE_ABS
#define SND_SEQ_TIME_MODE_ABS
Definition: seq_event.h:215
SND_SEQ_TIME_STAMP_TICK
#define SND_SEQ_TIME_STAMP_TICK
Definition: seq_event.h:211
SND_SEQ_TIME_MODE_REL
#define SND_SEQ_TIME_MODE_REL
Definition: seq_event.h:216
SND_SEQ_TIME_MODE_MASK
#define SND_SEQ_TIME_MODE_MASK
Definition: seq_event.h:217

set tick-scheduling mode on queue

Parameters

  ev | event instance
  q | queue id to schedule
  relative | relative time-stamp if non-zero
  ttick | tick time-stamp to be delivered

This macro sets the scheduling of the event in the MIDI tick mode.

See Also
  snd_seq_ev_schedule_real(), snd_seq_ev_set_direct()

#define snd_seq_ev_set_broadcast | ( |  | ev | ) |

Value:
((ev)->dest.client = SND_SEQ_ADDRESS_BROADCAST,\
(ev)->dest.port = SND_SEQ_ADDRESS_BROADCAST)
SND_SEQ_ADDRESS_BROADCAST
#define SND_SEQ_ADDRESS_BROADCAST
Definition: seq.h:71

set broadcasting to all clients/ports

Parameters

  ev | event record

This macro sets the destination as the broadcasting.

See Also
  snd_seq_ev_set_dest()

#define snd_seq_ev_set_chanpress | ( |  | ev,
|  |  | ch,
|  |  | val
| ) |  |

Value:
((ev)->type = SND_SEQ_EVENT_CHANPRESS,\
snd_seq_ev_set_fixed(ev),\
(ev)->data.control.channel = (ch),\
(ev)->data.control.value = (val))
snd_seq_ev_set_fixed
#define snd_seq_ev_set_fixed(ev)
set fixed data
Definition: seqmid.h:175
SND_SEQ_EVENT_CHANPRESS
Definition: seq_event.h:64

set channel pressure event

Parameters

  ev | event record
  ch | channel number
  val | channel pressure value

#define snd_seq_ev_set_controller | ( |  | ev,
|  |  | ch,
|  |  | cc,
|  |  | val
| ) |  |

Value:
((ev)->type = SND_SEQ_EVENT_CONTROLLER,\
snd_seq_ev_set_fixed(ev),\
(ev)->data.control.channel = (ch),\
(ev)->data.control.param = (cc),\
(ev)->data.control.value = (val))
SND_SEQ_EVENT_CONTROLLER
Definition: seq_event.h:60
snd_seq_ev_set_fixed
#define snd_seq_ev_set_fixed(ev)
set fixed data
Definition: seqmid.h:175

set MIDI controller event

Parameters

  ev | event record
  ch | channel number
  cc | controller number
  val | control value

#define snd_seq_ev_set_dest | ( |  | ev,
|  |  | c,
|  |  | p
| ) |  | ((ev)->dest.client = (c), (ev)->dest.port = (p))

set the explicit destination

Parameters

  ev | event record
  c | destination client id
  p | destination port id

This macro sets the client and port id numbers to the given event record.

See Also
  snd_seq_ev_set_subs()

#define snd_seq_ev_set_direct | ( |  | ev | ) | ((ev)->queue = SND_SEQ_QUEUE_DIRECT)

set direct passing mode (without queued)

Parameters

  ev | event instance

This macro sets the event to the direct passing mode to be delivered immediately without queueing.

See Also
  snd_seq_ev_schedule_tick(), snd_seq_ev_schedule_real()

#define snd_seq_ev_set_fixed | ( |  | ev | ) |

Value:
((ev)->flags &= ~SND_SEQ_EVENT_LENGTH_MASK,\
(ev)->flags |= SND_SEQ_EVENT_LENGTH_FIXED)
SND_SEQ_EVENT_LENGTH_FIXED
#define SND_SEQ_EVENT_LENGTH_FIXED
Definition: seq_event.h:219
SND_SEQ_EVENT_LENGTH_MASK
#define SND_SEQ_EVENT_LENGTH_MASK
Definition: seq_event.h:222

set fixed data

Parameters

  ev | event instance

Sets the event length mode as fixed size.

See Also
  snd_seq_ev_set_variable(), snd_seq_ev_set_varusr()

#define snd_seq_ev_set_keypress | ( |  | ev,
|  |  | ch,
|  |  | key,
|  |  | vel
| ) |  |

Value:
((ev)->type = SND_SEQ_EVENT_KEYPRESS,\
snd_seq_ev_set_fixed(ev),\
(ev)->data.note.channel = (ch),\
(ev)->data.note.note = (key),\
(ev)->data.note.velocity = (vel))
snd_seq_ev_set_fixed
#define snd_seq_ev_set_fixed(ev)
set fixed data
Definition: seqmid.h:175
SND_SEQ_EVENT_KEYPRESS
Definition: seq_event.h:57

set key-pressure event

Parameters

  ev | event record
  ch | channel number
  key | note key
  vel | velocity

#define snd_seq_ev_set_note | ( |  | ev,
|  |  | ch,
|  |  | key,
|  |  | vel,
|  |  | dur
| ) |  |

Value:
((ev)->type = SND_SEQ_EVENT_NOTE,\
snd_seq_ev_set_fixed(ev),\
(ev)->data.note.channel = (ch),\
(ev)->data.note.note = (key),\
(ev)->data.note.velocity = (vel),\
(ev)->data.note.duration = (dur))
SND_SEQ_EVENT_NOTE
Definition: seq_event.h:51
snd_seq_ev_set_fixed
#define snd_seq_ev_set_fixed(ev)
set fixed data
Definition: seqmid.h:175

set note event

Parameters

  ev | event record
  ch | channel number
  key | note key
  vel | velocity
  dur | duration (in tick or msec)

#define snd_seq_ev_set_noteoff | ( |  | ev,
|  |  | ch,
|  |  | key,
|  |  | vel
| ) |  |

Value:
((ev)->type = SND_SEQ_EVENT_NOTEOFF,\
snd_seq_ev_set_fixed(ev),\
(ev)->data.note.channel = (ch),\
(ev)->data.note.note = (key),\
(ev)->data.note.velocity = (vel))
snd_seq_ev_set_fixed
#define snd_seq_ev_set_fixed(ev)
set fixed data
Definition: seqmid.h:175
SND_SEQ_EVENT_NOTEOFF
Definition: seq_event.h:55

set note-off event

Parameters

  ev | event record
  ch | channel number
  key | note key
  vel | velocity

#define snd_seq_ev_set_noteon | ( |  | ev,
|  |  | ch,
|  |  | key,
|  |  | vel
| ) |  |

Value:
((ev)->type = SND_SEQ_EVENT_NOTEON,\
snd_seq_ev_set_fixed(ev),\
(ev)->data.note.channel = (ch),\
(ev)->data.note.note = (key),\
(ev)->data.note.velocity = (vel))
SND_SEQ_EVENT_NOTEON
Definition: seq_event.h:53
snd_seq_ev_set_fixed
#define snd_seq_ev_set_fixed(ev)
set fixed data
Definition: seqmid.h:175

set note-on event

Parameters

  ev | event record
  ch | channel number
  key | note key
  vel | velocity

#define snd_seq_ev_set_pgmchange | ( |  | ev,
|  |  | ch,
|  |  | val
| ) |  |

Value:
((ev)->type = SND_SEQ_EVENT_PGMCHANGE,\
snd_seq_ev_set_fixed(ev),\
(ev)->data.control.channel = (ch),\
(ev)->data.control.value = (val))
snd_seq_ev_set_fixed
#define snd_seq_ev_set_fixed(ev)
set fixed data
Definition: seqmid.h:175
SND_SEQ_EVENT_PGMCHANGE
Definition: seq_event.h:62

set program change event

Parameters

  ev | event record
  ch | channel number
  val | program number

#define snd_seq_ev_set_pitchbend | ( |  | ev,
|  |  | ch,
|  |  | val
| ) |  |

Value:
((ev)->type = SND_SEQ_EVENT_PITCHBEND,\
snd_seq_ev_set_fixed(ev),\
(ev)->data.control.channel = (ch),\
(ev)->data.control.value = (val))
SND_SEQ_EVENT_PITCHBEND
Definition: seq_event.h:66
snd_seq_ev_set_fixed
#define snd_seq_ev_set_fixed(ev)
set fixed data
Definition: seqmid.h:175

set pitch-bend event

Parameters

  ev | event record
  ch | channel number
  val | pitch bend; zero centered from -8192 to 8191

#define snd_seq_ev_set_priority | ( |  | ev,
|  |  | high_prior
| ) |  |

Value:
((ev)->flags &= ~SND_SEQ_PRIORITY_MASK,\
(ev)->flags |= (high_prior) ? SND_SEQ_PRIORITY_HIGH : SND_SEQ_PRIORITY_NORMAL)
SND_SEQ_PRIORITY_MASK
#define SND_SEQ_PRIORITY_MASK
Definition: seq_event.h:226
SND_SEQ_PRIORITY_HIGH
#define SND_SEQ_PRIORITY_HIGH
Definition: seq_event.h:225
SND_SEQ_PRIORITY_NORMAL
#define SND_SEQ_PRIORITY_NORMAL
Definition: seq_event.h:224

set event priority

Parameters

  ev | event instance
  high_prior | 1 for high priority mode

#define snd_seq_ev_set_queue_continue | ( |  | ev,
|  |  | q
| ) |  | snd_seq_ev_set_queue_control(ev, SND_SEQ_EVENT_CONTINUE, q, 0)

set the stop queue event

Parameters

  ev | event record
  q | queue id to continue

See Also
  snd_seq_ev_set_queue_start(), snd_seq_ev_set_queue_stop()

#define snd_seq_ev_set_queue_control | ( |  | ev,
|  |  | typ,
|  |  | q,
|  |  | val
| ) |  |

Value:
((ev)->type = (typ),\
snd_seq_ev_set_dest(ev, SND_SEQ_CLIENT_SYSTEM, SND_SEQ_PORT_SYSTEM_TIMER),\
(ev)->data.queue.queue = (q),\
(ev)->data.queue.param.value = (val))
SND_SEQ_PORT_SYSTEM_TIMER
#define SND_SEQ_PORT_SYSTEM_TIMER
Definition: seq.h:210
snd_seq_ev_set_dest
#define snd_seq_ev_set_dest(ev, c, p)
set the explicit destination
Definition: seqmid.h:71
SND_SEQ_CLIENT_SYSTEM
#define SND_SEQ_CLIENT_SYSTEM
Definition: seq.h:74

set queue controls

Parameters

  ev | event record
  typ | event type
  q | queue id
  val | control value

#define snd_seq_ev_set_queue_pos_real | ( |  | ev,
|  |  | q,
|  |  | rtime
| ) |  |

Value:
((ev)->type = SND_SEQ_EVENT_SETPOS_TIME,\
snd_seq_ev_set_dest(ev, SND_SEQ_CLIENT_SYSTEM, SND_SEQ_PORT_SYSTEM_TIMER),\
(ev)->data.queue.queue = (q),\
(ev)->data.queue.param.time.time = *(rtime))
SND_SEQ_PORT_SYSTEM_TIMER
#define SND_SEQ_PORT_SYSTEM_TIMER
Definition: seq.h:210
snd_seq_ev_set_dest
#define snd_seq_ev_set_dest(ev, c, p)
set the explicit destination
Definition: seqmid.h:71
SND_SEQ_EVENT_SETPOS_TIME
Definition: seq_event.h:94
SND_SEQ_CLIENT_SYSTEM
#define SND_SEQ_CLIENT_SYSTEM
Definition: seq.h:74

set the real-time position of a queue

Parameters

  ev | event record
  q | queue id to change tempo
  rtime | the new real-time pointer

#define snd_seq_ev_set_queue_pos_tick | ( |  | ev,
|  |  | q,
|  |  | ttime
| ) |  |

Value:
((ev)->type = SND_SEQ_EVENT_SETPOS_TICK,\
snd_seq_ev_set_dest(ev, SND_SEQ_CLIENT_SYSTEM, SND_SEQ_PORT_SYSTEM_TIMER),\
(ev)->data.queue.queue = (q),\
(ev)->data.queue.param.time.tick = (ttime))
SND_SEQ_PORT_SYSTEM_TIMER
#define SND_SEQ_PORT_SYSTEM_TIMER
Definition: seq.h:210
snd_seq_ev_set_dest
#define snd_seq_ev_set_dest(ev, c, p)
set the explicit destination
Definition: seqmid.h:71
SND_SEQ_CLIENT_SYSTEM
#define SND_SEQ_CLIENT_SYSTEM
Definition: seq.h:74
SND_SEQ_EVENT_SETPOS_TICK
Definition: seq_event.h:92

set the tick-time position of a queue

Parameters

  ev | event record
  q | queue id to change tempo
  ttime | the new tick-time

#define snd_seq_ev_set_queue_start | ( |  | ev,
|  |  | q
| ) |  | snd_seq_ev_set_queue_control(ev, SND_SEQ_EVENT_START, q, 0)

set the start queue event

Parameters

  ev | event record
  q | queue id to start

See Also
  snd_seq_ev_set_queue_stop(), snd_seq_ev_set_queue_continue()

#define snd_seq_ev_set_queue_stop | ( |  | ev,
|  |  | q
| ) |  | snd_seq_ev_set_queue_control(ev, SND_SEQ_EVENT_STOP, q, 0)

set the stop queue event

Parameters

  ev | event record
  q | queue id to stop

See Also
  snd_seq_ev_set_queue_start(), snd_seq_ev_set_queue_continue()

#define snd_seq_ev_set_queue_tempo | ( |  | ev,
|  |  | q,
|  |  | val
| ) |  | snd_seq_ev_set_queue_control(ev, SND_SEQ_EVENT_TEMPO, q, val)

set the stop queue event

Parameters

  ev | event record
  q | queue id to change tempo
  val | the new tempo value

#define snd_seq_ev_set_source | ( |  | ev,
|  |  | p
| ) |  | ((ev)->source.port = (p))

set the source port

Parameters

  ev | event record
  p | source port id

This macro sets the source port id number.

#define snd_seq_ev_set_subs | ( |  | ev | ) |

Value:
((ev)->dest.client = SND_SEQ_ADDRESS_SUBSCRIBERS,\
(ev)->dest.port = SND_SEQ_ADDRESS_UNKNOWN)
SND_SEQ_ADDRESS_SUBSCRIBERS
#define SND_SEQ_ADDRESS_SUBSCRIBERS
Definition: seq.h:70
SND_SEQ_ADDRESS_UNKNOWN
#define SND_SEQ_ADDRESS_UNKNOWN
Definition: seq.h:69

set broadcasting to subscribers

Parameters

  ev | event record

This macro sets the destination as the subscribers.

See Also
  snd_seq_ev_set_dest()

#define snd_seq_ev_set_sysex | ( |  | ev,
|  |  | datalen,
|  |  | dataptr
| ) |  |

Value:
((ev)->type = SND_SEQ_EVENT_SYSEX,\
snd_seq_ev_set_variable(ev, datalen, dataptr))
SND_SEQ_EVENT_SYSEX
Definition: seq_event.h:158
snd_seq_ev_set_variable
#define snd_seq_ev_set_variable(ev, datalen, dataptr)
set variable data
Definition: seqmid.h:189

set sysex event

Parameters

  ev | event record
  datalen | length of sysex data
  dataptr | sysex data pointer

the sysex data must contain the start byte 0xf0 and the end byte 0xf7.

#define snd_seq_ev_set_tag | ( |  | ev,
|  |  | t
| ) |  | ((ev)->tag = (t))

set the tag for given event

Parameters

  ev | event record
  t | event tag

This macro sets the tag to the given event record.

#define snd_seq_ev_set_variable | ( |  | ev,
|  |  | datalen,
|  |  | dataptr
| ) |  |

Value:
((ev)->flags &= ~SND_SEQ_EVENT_LENGTH_MASK,\
(ev)->flags |= SND_SEQ_EVENT_LENGTH_VARIABLE,\
(ev)->data.ext.len = (datalen),\
(ev)->data.ext.ptr = (dataptr))
SND_SEQ_EVENT_LENGTH_VARIABLE
#define SND_SEQ_EVENT_LENGTH_VARIABLE
Definition: seq_event.h:220
SND_SEQ_EVENT_LENGTH_MASK
#define SND_SEQ_EVENT_LENGTH_MASK
Definition: seq_event.h:222

set variable data

Parameters

  ev | event instance
  datalen | length of the external data
  dataptr | pointer of the external data

Sets the event length mode as variable length and stores the data.

See Also
  snd_seq_ev_set_fixed(), snd_seq_ev_set_varusr()

#define snd_seq_ev_set_varusr | ( |  | ev,
|  |  | datalen,
|  |  | dataptr
| ) |  |

Value:
((ev)->flags &= ~SND_SEQ_EVENT_LENGTH_MASK,\
(ev)->flags |= SND_SEQ_EVENT_LENGTH_VARUSR,\
(ev)->data.ext.len = (datalen),\
(ev)->data.ext.ptr = (dataptr))
SND_SEQ_EVENT_LENGTH_VARUSR
#define SND_SEQ_EVENT_LENGTH_VARUSR
Definition: seq_event.h:221
SND_SEQ_EVENT_LENGTH_MASK
#define SND_SEQ_EVENT_LENGTH_MASK
Definition: seq_event.h:222

set varusr data

Parameters

  ev | event instance
  datalen | length of the external data
  dataptr | pointer of the external data

Sets the event length mode as variable user-space data and stores the data.

See Also
  snd_seq_ev_set_fixed(), snd_seq_ev_set_variable()

#define snd_seq_start_queue | ( |  | seq,
|  |  | q,
|  |  | ev
| ) |  | snd_seq_control_queue(seq, q, SND_SEQ_EVENT_START, 0, ev)

start the specified queue

Parameters

  seq | sequencer handle
  q | queue id to start
  ev | optional event record (see snd_seq_control_queue)

#define snd_seq_stop_queue | ( |  | seq,
|  |  | q,
|  |  | ev
| ) |  | snd_seq_control_queue(seq, q, SND_SEQ_EVENT_STOP, 0, ev)

stop the specified queue

Parameters

  seq | sequencer handle
  q | queue id to stop
  ev | optional event record (see snd_seq_control_queue)

## Function Documentation

int snd_seq_connect_from | ( | snd_seq_t * | seq,
|  | int | myport,
|  | int | src_client,
|  | int | src_port
| ) |  |

simple subscription (w/o exclusive & time conversion)

Parameters

  seq | sequencer handle
  myport | the port id as receiver
  src_client | sender client id
  src_port | sender port id

Returns
  0 on success or negative error code

Connect from the given sender client:port to the given destination port in the current client.

See Also
  snd_seq_subscribe_port(), snd_seq_disconnect_from()

int snd_seq_connect_to | ( | snd_seq_t * | seq,
|  | int | myport,
|  | int | dest_client,
|  | int | dest_port
| ) |  |

simple subscription (w/o exclusive & time conversion)

Parameters

  seq | sequencer handle
  myport | the port id as sender
  dest_client | destination client id
  dest_port | destination port id

Returns
  0 on success or negative error code

Connect from the given receiver port in the current client to the given destination client:port.

See Also
  snd_seq_subscribe_port(), snd_seq_disconnect_to()

int snd_seq_control_queue | ( | snd_seq_t * | seq,
|  | int | q,
|  | int | type,
|  | int | value,
|  | snd_seq_event_t * | ev
| ) |  |

queue controls - start/stop/continue

Parameters

  seq | sequencer handle
  q | queue id to control
  type | event type
  value | event value
  ev | event instance

This function sets up general queue control event and sends it. To send at scheduled time, set the schedule in ev. If ev is NULL, the event is composed locally and sent immediately to the specified queue. In any cases, you need to call snd_seq_drain_output() appropriately to feed the event.

See Also
  snd_seq_alloc_queue()

int snd_seq_create_simple_port | ( | snd_seq_t * | seq,
|  | const char * | name,
|  | unsigned int | caps,
|  | unsigned int | type
| ) |  |

create a port - simple version

Parameters

  seq | sequencer handle
  name | the name of the port
  caps | capability bits
  type | type bits

Returns
  the created port number or negative error code

Creates a port with the given capability and type bits.

See Also
  snd_seq_create_port(), snd_seq_delete_simple_port()

int snd_seq_delete_simple_port | ( | snd_seq_t * | seq,
|  | int | port
| ) |  |

delete the port

Parameters

  seq | sequencer handle
  port | port id

Returns
  0 on success or negative error code

See Also
  snd_seq_delete_port(), snd_seq_create_simple_port()

int snd_seq_disconnect_from | ( | snd_seq_t * | seq,
|  | int | myport,
|  | int | src_client,
|  | int | src_port
| ) |  |

simple disconnection

Parameters

  seq | sequencer handle
  myport | the port id as receiver
  src_client | sender client id
  src_port | sender port id

Returns
  0 on success or negative error code

Remove connection from the given sender client:port to the given destination port in the current client.

See Also
  snd_seq_unsubscribe_port(), snd_seq_connect_from()

int snd_seq_disconnect_to | ( | snd_seq_t * | seq,
|  | int | myport,
|  | int | dest_client,
|  | int | dest_port
| ) |  |

simple disconnection

Parameters

  seq | sequencer handle
  myport | the port id as sender
  dest_client | destination client id
  dest_port | destination port id

Returns
  0 on success or negative error code

Remove connection from the given sender client:port to the given destination port in the current client.

See Also
  snd_seq_unsubscribe_port(), snd_seq_connect_to()

int snd_seq_parse_address | ( | snd_seq_t * | seq,
|  | snd_seq_addr_t * | addr,
|  | const char * | arg
| ) |  |

parse the given string and get the sequencer address

Parameters

  seq | sequencer handle
  addr | the address pointer to be returned
  arg | the string to be parsed

Returns
  0 on success or negative error code

This function parses the sequencer client and port numbers from the given string. The client and port tokens are separated by either colon or period, e.g. 128:1. When seq is not NULL, the function accepts also a client name not only digit numbers. Actually arg need to be only a prefix of the wanted client. That is, if a client named "Foobar XXL Master 2012" with number 128 is available, then parsing "Foobar" will return the address 128:0 if no other client is an exact match.

int snd_seq_reset_pool_input | ( | snd_seq_t * | seq | ) |

reset client input pool

Parameters

  seq | sequencer handle

Returns
  0 on success or negative error code

So far, this works identically like snd_seq_drop_input().

int snd_seq_reset_pool_output | ( | snd_seq_t * | seq | ) |

reset client output pool

Parameters

  seq | sequencer handle

Returns
  0 on success or negative error code

So far, this works identically like snd_seq_drop_output().

int snd_seq_set_client_event_filter | ( | snd_seq_t * | seq,
|  | int | event_type
| ) |  |

add client event filter

Parameters

  seq | sequencer handle
  event_type | event type to be added

Returns
  0 on success or negative error code

See Also
  snd_seq_set_client_info()

int snd_seq_set_client_name | ( | snd_seq_t * | seq,
|  | const char * | name
| ) |  |

set client name

Parameters

  seq | sequencer handle
  name | name string

Returns
  0 on success or negative error code

See Also
  snd_seq_set_client_info()

int snd_seq_set_client_pool_input | ( | snd_seq_t * | seq,
|  | size_t | size
| ) |  |

change the input pool size of the given client

Parameters

  seq | sequencer handle
  size | input pool size

Returns
  0 on success or negative error code

See Also
  snd_seq_set_client_pool()

int snd_seq_set_client_pool_output | ( | snd_seq_t * | seq,
|  | size_t | size
| ) |  |

change the output pool size of the given client

Parameters

  seq | sequencer handle
  size | output pool size

Returns
  0 on success or negative error code

See Also
  snd_seq_set_client_pool()

int snd_seq_set_client_pool_output_room | ( | snd_seq_t * | seq,
|  | size_t | size
| ) |  |

change the output room size of the given client

Parameters

  seq | sequencer handle
  size | output room size

Returns
  0 on success or negative error code

See Also
  snd_seq_set_client_pool()

int snd_seq_sync_output_queue | ( | snd_seq_t * | seq | ) |

wait until all events are processed

Parameters

  seq | sequencer handle

Returns
  0 on success or negative error code

This function waits until all events of this client are processed.

See Also
  snd_seq_drain_output()